-- ------------------------------------------------------------------------------
-- RP Tags
-- by Oraibi, Moon Guard (US) server
--
-- Ora's twitter: http://twitter.com/oraibimoonguard
-- Download site: http://tinyurl.com/rptags-tukui
-- Documentation: http://tinyurl.com/rptags-wiki
--
-- ------------------------------------------------------------------------------
--
-- This work is licensed under the Creative Commons Attribution 4.0 International
-- (CC BY 4.0) license. To view a copy of the license, visit
--
--     https://creativecommons.org/licenses/by/4.0/
--
-- This license is acceptable for Free Cultural Works.
--
-- You are free to:
--
-- Share -- copy and redistribute the material in any medium or format
-- Adapt -- remix, transform, and build upon the material
--         for any purpose, even commercially.
-- 
-- The licensor cannot revoke these freedoms as long as you follow the 
-- license terms.
-- 
-- Under the following terms:
-- Attribution -- You must give appropriate credit, provide a link to the
--         license, and indicate if changes were made. You may do
--         so in any reasonable manner, but not in any way that
--         suggests the licensor endorses you or your use.
--
-- No additional restrictions -- You may not apply legal terms or
--         technological measures that legally restrict others from doing
--         anything the license permits.
--
-- Notices:
--
-- You do not have to comply with the license for elements of the material
-- in the public domain or where your use is permitted by an applicable
-- exception or limitation.
--
-- No warranties are given. The license may not give you all of the
-- permissions necessary for your intended use. For example, other rights
-- such as publicity, privacy, or moral rights may limit how you use the
-- material.
-- ------------------------------------------------------------------------------

-- Const-icons: Icon constants
--
-- available under RPTAGS.const.icons
--
local RPTAGS = RPTAGS;

table.insert(RPTAGS.startup, function() -- startup function
  local Const = RPTAGS.const;
  
    -- TexturePath:size1:size2:xoffset:yoffset:dimx:dimy:coordx1:coordx2:coordy1:coordy2
    -- path       :0    :0    :0      :0      :64  :64  :0      :64     :0      :64     
    --
  Const.icons = {
    T_          = "|TInterface\\",
    _t          = ":0|t",
  
    BATTLE_1    = "ICONS\\UI_RankedPvP_05_Small",
    BATTLE_2    = "ICONS\\INV_Misd_Dice_01",
    BATTLE_3    = "ICONS\\INV_Misc_Dice_02",
    BATTLE_4    = "ICONS\\Ability_Rogue_Disguise", 
  
    DEATH_1     = "ICONS\\Spell_Shadow_RaiseDead", 
    DEATH_2     = "ICONS\\INV_Elemental_Eternal_Life", 
    DEATH_3     = "RAIDFRAME\\ReadyCheck-Waiting",
  
    GUILD_1     = "ICONS\\Achievement_Reputation_06",
    GUILD_2     = "ICONS\\INV_Mask_01",
  
    IC_1        = "ICONS\\Achievement_LegionPVP3Tier4",
    IC_2        = "ICONS\\Ability_Racial_TimeIsMoney",
    IC_3        = "ICONS\\artifactability_BalanceDruid_HalfMoon",
    IC_4        = "ICONS\\INV_Misc_Basket_01", 
    IC_5        = "ICONS\\UI_Calendar_FreeTShirtDay", 
  
    INJURY_1    = "ICONS\\Ability_Butcher_GushingWounds",
    INJURY_2    = "ICONS\\Ability_Priest_ReflectiveShield",
    INJURY_3    = "RAIDFRAME\\ReadyCheck-Waiting",
  
    ROMANCE_1   = "ICONS\\INV_ValentinesCandy",
    ROMANCE_2   = "ICONS\\Spell_BrokenHeart",
    ROMANCE_3   = "RAIDFRAME\\ReadyCheck-Waiting",
  
    XP_1        = "TARGETINGFRAME\\UI-TargetingFrame-Seal",
    XP_2        = "ICONS\\XP_ICON",
    XP_3        = "TARGETINGFRAME\\PortraitQuestBadge",
  
    -- TexturePath:size1:size2:xoffset:yoffset:dimx:dimy:coordx1:coordx2:coordy1:coordy2
    --            :0    :     :0      :0      :128 :64  :64     :128    :0      :64"            ,
    -- path       :0    :0    :0      :0      :64  :64  :0      :64     :0      :64     
    COLORWHEEL  = "|TInterface\\OptionsFrame\\ColorblindSettings:0::0:0:256:256:0:148:0:148|t",
    MORE      = "Calendar\\MoreArrow",
    -- COLORWHEEL  = "|Acolorblind-colorwheel:0|a",
    AFK       = "FriendsFrame\\StatusIcon-Away"                     ,
    DND       = "FriendsFrame\\StatusIcon-DnD"                      ,
    -- OOC       = "COMMON\\Indicator-Red"                             ,
    OOC       = "RAIDFRAME\\ReadyCheck-NotReady",
    IC        = "RAIDFRAME\\ReadyCheck-Ready",
    STATUS    = "COMMON\\Indicator-Gray"                            ,
    ALLIANCE  = "GROUPFRAME\\UI-Group-PVP-Alliance"                 ,
    HORDE     = "GROUPFRAME\\UI-Group-PVP-Horde"                    ,
    PVP       = "GossipFrame\\BattleMasterGossipIcon"               ,
    BEGINNER  = "TARGETINGFRAME\\UI-TargetingFrame-Seal"            ,
    VOLUNTEER = "TARGETINGFRAME\\PortraitQuestBadge"                ,
    BANNED    = "EncounterJournal\\UI-EJ-HeroicTextIcon"            ,
    GLANCE    = "MINIMAP\\TRACKING\\None"                           ,
    NEW_ABOUT = "Buttons\\UI-GuildButton-PublicNote-Up"             ,
    GENDER    = {
      NEUTER  = "ICONS\\Achievement_GuildPerk_EverybodysFriend"     ,
      UNKNOWN = "InventoryItems\\WoWUnknownItem01"                  ,
      THEY    = "ICONS\\Achievement_DoubleRainbow"                  ,
      MALE    = "Glues\\CHARACTERCREATE\\UI-CharacterCreate-Gender" ,
      FEMALE  = "Glues\\CHARACTERCREATE\\UI-CharacterCreate-Gender" ,
      },
    PARAMS    = { DEFAULT = "0::0:0:64:64:0:64:0:64"               , 
                  MALE    = "0::0:0:128:64:0:64:0:64"              ,
                  FEMALE  = "0::0:0:128:64:64:128:0:64"            ,
                  },
  }
  return "const-gender";
end); -- startup function

