-- ------------------------------------------------------------------------------
-- RP Tags
-- by Oraibi, Moon Guard (US) server
--
-- Ora's twitter: http://twitter.com/oraibimoonguard
-- Download site: http://tinyurl.com/rptags-tukui
-- Documentation: http://tinyurl.com/rptags-wiki
--
-- ------------------------------------------------------------------------------
--
-- This work is licensed under the Creative Commons Attribution 4.0 International
-- (CC BY 4.0) license. To view a copy of the license, visit
--
--     https://creativecommons.org/licenses/by/4.0/
--
-- This license is acceptable for Free Cultural Works.
--
-- You are free to:
--
-- Share -- copy and redistribute the material in any medium or format
-- Adapt -- remix, transform, and build upon the material
--         for any purpose, even commercially.
-- 
-- The licensor cannot revoke these freedoms as long as you follow the 
-- license terms.
-- 
-- Under the following terms:
-- Attribution -- You must give appropriate credit, provide a link to the
--         license, and indicate if changes were made. You may do
--         so in any reasonable manner, but not in any way that
--         suggests the licensor endorses you or your use.
--
-- No additional restrictions -- You may not apply legal terms or
--         technological measures that legally restrict others from doing
--         anything the license permits.
--
-- Notices:
--
-- You do not have to comply with the license for elements of the material
-- in the public domain or where your use is permitted by an applicable
-- exception or limitation.
--
-- No warranties are given. The license may not give you all of the
-- permissions necessary for your intended use. For example, other rights
-- such as publicity, privacy, or moral rights may limit how you use the
-- material.
-- ------------------------------------------------------------------------------

--
-- available under RPTAGS.const.CONFIG
--
local RPTAGS = RPTAGS;

table.insert(RPTAGS.startup, function() -- startup function
  
    -- ----------------- - Temporary values that are used later 
  local CYAN              = "ff3399";
  local GREEN             = "33ff33";
  local GREY              = "999999";
  local YELLOW            = "ffff66";
  local LITE_GREY         = "bbbbbb";
  local ORANGE            = "ff9966"; 
  local PINK              = "ff66ff";
  local RED               = "ff3333";
  local LITE_BLUE         = "00bbbb";
  local WHITE             = "ffffff";
  local BLACK             = "000000";
  local ORA_COLOR         = "bb00bb";
  local VIOLET            = "aa00cc";
  
  RPTAGS.const.COLOR_GREEN = GREEN;
  RPTAGS.const.COLOR_RED   = RED;
  
  local settings = {
    CONFIG_PAGES = {
      MAIN       = "main_config_rptags_aaa_main",
      FORMATTING = "main_config_rptags_bbb_formatting",
      COLORS     = "main_config_rptags_ccc_colors",
      LAYOUT     = "main_config_rptags_ddd_rpuf_layout",
      PANELS     = "main_config_rptags_eee_rpuf_panels",
      REFERENCE  = "main_config_rptags_zzz_reference",
    }, -- CONFIGPAGES
    PAGES = {}, -- filled in later
    KEYS = {     
      -- IC_ONLY            = "rptags_ic_only", -- removed
      ADULT_GENDERS      = "rptags_adult_gender",
      CHANGES_MESSAGE    = "rptags_changes_message",

      COLOR_EQUALISH     = "rptags_color_equalish",
      COLOR_FEMALE       = "rptags_gendercolor_female",
      COLOR_GREATERTHAN  = "rptags_color_greaterthan",
      COLOR_HILITE_1     = "rptags_color_hilite_1",
      COLOR_HILITE_2     = "rptags_color_hilite_2",
      COLOR_HILITE_3     = "rptags_color_hilite_3",
      COLOR_IC           = "rptags_color_status_ic",
      COLOR_LESSTHAN     = "rptags_color_lessthan",
      COLOR_MALE         = "rptags_gendercolor_male",
      COLOR_NEUTER       = "rptags_gendercolor_neuter",
      COLOR_NPC          = "rptags_color_status_npc",
      COLOR_OOC          = "rptags_color_status_ooc",
      COLOR_RPUF         = "rptags_rpuf_frame_background_color",
      COLOR_THEY         = "rptags_gendercolor_they",
      COLOR_UNKNOWN      = "rptags_color_unknown",

      CURR_SIZE          = "rptags_size_currently",
      CURR_WRAP          = "rptags_wrap_currently",
      DETAILHEIGHT       = "rptags_rpuf_details_panel_height",
      DETAILPANEL        = "rptags_rpuf_details_panel_contents",
      DETAIL_TOOLTIP     = "rptags_rpuf_tooltips_details_panel",
      DISABLE_BLIZZARD   = "rptags_rpuf_disable_blizzard",
      ENABLE_BLIZZARD    = "rptags_rpuf_enable_blizzard",
      FOCUSLAYOUT        = "rptags_rpuf_focus_and_targettarget_layout",
      GAPSIZE            = "rptags_rpuf_layout_gap_size",
      GLANCETITLE_SIZE   = "rptags_size_glancetitle",
      GLANCETITLE_WRAP   = "rptags_wrap_glancetitle",
      GLANCE_COLON       = "rptags_at_first_glance_colon",
      GLANCE_DELIM       = "rptags_at_first_glance_delimiter",
      GLANCE_SIZE        = "rptags_size_glance",
      GLANCE_WRAP        = "rptags_wrap_glance",
      HIDDEN_RPUF_WITH_ELVUI = "rptags_rpuf_runs_with_elvui_hidden_setting",
      ICONWIDTH          = "rptags_rpuf_icon_panel_width",
      ICON_1             = "rptags_rpuf_icon_1_slot_contents",
      ICON_1_TOOLTIP     = "rptags_rpuf_tooltips_icon_slot_1",
      ICON_2             = "rptags_rpuf_icon_2_slot_contents",
      ICON_2_TOOLTIP     = "rptags_rpuf_tooltips_icon_slot_2",
      ICON_3             = "rptags_rpuf_icon_3_slot_contents",
      ICON_3_TOOLTIP     = "rptags_rpuf_tooltips_icon_slot_3",
      ICON_4             = "rptags_rpuf_icon_4_slot_contents",
      ICON_4_TOOLTIP     = "rptags_rpuf_tooltips_icon_slot_4",
      ICON_5             = "rptags_rpuf_icon_5_slot_contents",
      ICON_5_TOOLTIP     = "rptags_rpuf_tooltips_icon_slot_5",
      ICON_6             = "rptags_rpuf_icon_6_slot_contents",
      ICON_6_TOOLTIP     = "rptags_rpuf_tooltips_icon_slot_6",
      INFOPANEL          = "rptags_rpuf_info_panel_contents",
      INFOWIDTH          = "rptags_rpuf_info_panel_width",
      INFO_TOOLTIP       = "rptags_rpuf_tooltips_info_panel",
      LINEBREAKS         = "rptags_linebreaks",
      LOCK_FRAMES        = "rptags_rpuf_lock_frames", 
      LOGIN_MESSAGE      = "rptags_login_message",
      MISC_SIZE          = "rptags_size_misc",
      MISC_WRAP          = "rptags_wrap_misc",
      NAMEPANEL          = "rptags_rpuf_name_panel_contents",
      NAME_SIZE          = "rptags_size_name",
      NAME_TOOLTIP       = "rptags_rpuf_tooltips_name_panel",
      NAME_WRAP          = "rptags_wrap_name",
      NOTE_1_ICON        = "rptags_notes_alert_1_icon",
      NOTE_1_STRING      = "rptags_notes_alert_1",
      NOTE_2_ICON        = "rptags_notes_alert_2_icon",
      NOTE_2_STRING      = "rptags_notes_alert_2",
      NOTE_3_ICON        = "rptags_notes_alert_3_icon",
      NOTE_3_STRING      = "rptags_notes_alert_3",
      PARSE_AGE          = "rptags_parse_age",
      PARSE_GENDER       = "rptags_parse_gender",
      PARSE_HW           = "rptags_parse_height_weight",
      PARTYLAYOUT        = "rptags_rpuf_party_and_raid_layout",  -- not yet implemented
      PLAYERLAYOUT       = "rptags_rpuf_player_layout",
      PORTRAIT_TOOLTIP   = "rptags_rpuf_tooltips_portrait",
      PORTRAIT_TYPE      = "rptags_rpuf_portrait_type_camera",
      PORTWIDTH          = "rptags_rpuf_portrait_width",
      PROFILESIZE_FMT    = "rptags_profilesize_format",
      RAIDLAYOUT         = "rptags_rpuf_raid_layout",            -- not yet implemented
      REAL_ELLIPSES      = "rptags_real_ellipses",
      REF_TOPIC          = "rptags_reference_topic",
      RESET_FRAMES       = "rptags_rpuf_reset_frame_dimensions",
      RESET_TAGS         = "rptags_rpuf_reset_tag_values",
      RESET_COLORS       = "rptags_colors_reset",
      RPUFALPHA          = "rptags_rpuf_alpha",
      RPUF_BACKDROP      = "rptags_rpuf_backdrop_texture",
      RPUF_WITH_ELVUI    = "rptags_rpuf_runs_with_elvui",
      SIZEBUFF_FMT       = "rptags_sizebuffs_format",
      STATUSHEIGHT       = "rptags_rpuf_status_panel_height",
      STATUSPANEL        = "rptags_rpuf_status_panel_contents",
      STATUS_TOOLTIP     = "rptags_rpuf_tooltips_statusbar_panel",
      TARGETLAYOUT       = "rptags_rpuf_target_layout",
      TITLE_SIZE         = "rptags_size_title",
      TITLE_WRAP         = "rptags_wrap_title",
      UNITS_HEIGHT       = "rptags_units_height",
      UNITS_WEIGHT       = "rptags_units_weight",
 -- ## 
      }, -- KEYS
    DEFAULTS = { 
      NOTE_1_STRING      = "Warning:",
      NOTE_2_STRING      = "Reminder:",
      NOTE_3_STRING      = "Alt of",
      NOTE_1_ICON        = "INV_Misc_ScrollUnrolled03.PNG",
      NOTE_2_ICON        = "INV_Misc_ScrollUnrolled03d.PNG",
      NOTE_3_ICON        = "INV_Misc_ScrollUnrolled02c.PNG",
  
      ADULT_GENDERS      = false,
      CHANGES_MESSAGE    = true,
      COLOR_EQUALISH     = LITE_GREY,
      COLOR_FEMALE       = PINK,
      COLOR_GREATERTHAN  = LITE_BLUE,
      COLOR_HILITE_1     = CYAN,
      COLOR_HILITE_2     = YELLOW,
      COLOR_HILITE_3     = ORANGE,
      COLOR_IC           = GREEN,
      COLOR_LESSTHAN     = YELLOW,
      COLOR_MALE         = LITE_BLUE,
      COLOR_NEUTER       = LITE_GREY,
      COLOR_NPC          = LITE_GREY,
      COLOR_OOC          = RED,
      COLOR_THEY         = YELLOW,
      COLOR_UNKNOWN      = GREY,
      CURR_SIZE          = 30,
      CURR_WRAP          = "WRAP_ONCE",
      DISABLE_BLIZZARD   = false,
      ENABLE_BLIZZARD    = true,
      EXTEND_GENDER      = false,
      FORMATTING_TAGS    = true,
      GLANCETITLE_SIZE   = 30,
      GLANCETITLE_WRAP   = "WORD_TRUNC",
      GLANCE_COLON       = ": ",
      GLANCE_DELIM       = "\n",
      GLANCE_SIZE        = 30,
      GLANCE_WRAP        = "WORD_TRUNC",
      -- IC_ONLY            = false,
      LINEBREAKS         = false,
      LOGIN_MESSAGE      = true,
      MISC_SIZE          = 30,
      MISC_WRAP          = "WORD_TRUNC",
      NAME_SIZE          = 30,
      NAME_WRAP          = "TRUNCATE",
      PARSE_AGE          = false,
      PARSE_GENDER       = false,
      PARSE_HW           = false,
      PROFILESIZE_FMT    = "WRD_PAR_NUM",
      REAL_ELLIPSES      = true,
      SIZEBUFF_FMT       = "PCT_BRC",
      TITLE_SIZE         = 30,
      TITLE_WRAP         = "WORD_TRUNC",
      UNITS_HEIGHT       = "CM_FT_IN",
      UNITS_WEIGHT       = "KG_LB",
      RESET_FRAMES       = true,
      RESET_TAGS         = true,
      RESET_COLORS       = true,
  
      PLAYERLAYOUT       = "ABRIDGED",
      TARGETLAYOUT       = "FULL",
      FOCUSLAYOUT        = "COMPACT",
      PARTYLAYOUT        = "ABRIDGED",    -- not implemented yet
      RAIDLAYOUT         = "COMPACT",     -- not implemented yet
  
      ICON_1             = "[rp:icon]",
      ICON_2             = "[rp:glance-1-icon]",
      ICON_3             = "[rp:glance-2-icon]",
      ICON_4             = "[rp:glance-3-icon]",
      ICON_5             = "[rp:glance-4-icon]",
      ICON_6             = "[rp:glance-5-icon]",
  
      NAMEPANEL          = "[rp:color][rp:name]",
      INFOPANEL          = "[rp:race] [rp:class]",
      DETAILPANEL        = "[rp:oocinfo]",
      STATUSPANEL        = "[rp:statuscolor][rp:ic][rp:ooc] [nocolor][rp:currently]",

      PORTRAIT_TYPE      = "FACE",
  
      PORTRAIT_TOOLTIP   = "[rp:eyecolor][rp:eyes-label][nocolor][br][rp:hair-label][br][rp:faceclaim-label]",
      STATUS_TOOLTIP     = "[rp:statuscolor][rp:ic][rp:ooc] [nocolor][rp:currently-label]",
      NAME_TOOLTIP       = "[rp:namecolor][rp:friendcolor][rp:firstname] [rp:nick-quoted] [rp:lastname][nocolor][br][rp:title-long][p][rp:guildcolor][rp:guild-label][nocolor] [rp:guild-status][br][rp:guild-rank-label]",
      INFO_TOOLTIP       = "[rp:gendercolor][rp:gender][nocolor] [rp:guildcolor][race] [rp:friendcolor][class] [level]",
      DETAIL_TOOLTIP     = "[rp:statuscolor][rp:ic][rp:ooc][nocolor] [rp:oocinfo-label]",
      ICON_1_TOOLTIP     = "[rp:style-yes-label][br][rp:style-ask-label][br][rp:style-no-label]",
      ICON_2_TOOLTIP     = "[rp:glance-1-full]",
      ICON_3_TOOLTIP     = "[rp:glance-2-full]",
      ICON_4_TOOLTIP     = "[rp:glance-3-full]",
      ICON_5_TOOLTIP     = "[rp:glance-4-full]",
      ICON_6_TOOLTIP     = "[rp:glance-5-full]",
  
      INFOWIDTH          = 200,
      ICONWIDTH          = 25,
      PORTWIDTH          = 100,
      DETAILHEIGHT       = 100,
      GAPSIZE            = 6,
      STATUSHEIGHT       = 35,
  
      RPUFALPHA          = 65,
      REF_TOPIC          = "SETTINGS",
      LOCK_FRAMES        = false,
      COLOR_RPUF         = "000000",
      RPUF_WITH_ELVUI    = true,
      HIDDEN_RPUF_WITH_ELVUI = false,

      RPUF_BACKDROP      = "ORIGINAL",
  
    }, -- DEFAULTS
    CALLBACKS = {
      DISABLE_BLIZZARD   = function() StaticPopup_Show("RPTAGS_SAVE_AND_RELOAD") end,
      ENABLE_BLIZZARD    = function() StaticPopup_Show("RPTAGS_SAVE_AND_RELOAD") end,
  
      RESET_COLORS       = function() RPTAGS.utils.config.resetgroup({ "COLOR_EQUALISH", "COLOR_GREATERTHAN", "COLOR_LESSTHAN",
                                                                       "COLOR_FEMALE", "COLOR_MALE", "COLOR_NEUTER", "COLOR_THEY", "COLOR_UNKNOWN",
                                                                       "COLOR_HILITE_1", "COLOR_HILITE_2", "COLOR_HILITE_3",
                                                                       "COLOR_IC", "COLOR_NPC", "COLOR_OOC", }) 
                                      print(RPTAGS.utils.locale.loc("APP_COLOR_NAME") .. " " .. RPTAGS.utils.locale.loc("COLORS_ARE_RESET")) end,

      RESET_TAGS         = function() RPTAGS.utils.config.resetgroup({ 'ICON_1', 'ICON_2', 'ICON_3', 'ICON_4', 'ICON_5', 'ICON_6', 
                                                                       'DETAILPANEL', 'INFOPANEL', 'NAMEPANEL', 'STATUSPANEL', 
                                                                       'PORTRAIT_TOOLTIP', 'STATUS_TOOLTIP', 'NAME_TOOLTIP', 'INFO_TOOLTIP', 'DETAIL_TOOLTIP',
                                                                       'ICON_1_TOOLTIP', 'ICON_2_TOOLTIP', 'ICON_3_TOOLTIP', 'ICON_4_TOOLTIP', 'ICON_5_TOOLTIP', 'ICON_6_TOOLTIP',
                                                                       }) ;
                                      print(RPTAGS.utils.locale.loc("APP_COLOR_NAME") .. " " .. RPTAGS.utils.locale.loc("TAGS_ARE_RESET")) end,
  
      RESET_FRAMES       = function() RPTAGS.utils.config.resetgroup({ -- 'RPUFALPHA',  "COLOR_RPUF",
                                                                       'ICONWIDTH', 'INFOWIDTH', 'PORTWIDTH', 'STATUSHEIGHT', 
                                                                       'GAPSIZE', 
                                                                       -- 'FOCUSLAYOUT', 'PARTYLAYOUT', 'PLAYERLAYOUT', 'TARGETLAYOUT', 'RAIDLAYOUT', 
                                                                       }, "main_config_rptags_ddd_rpuf_layout");
                                      RPTAGS.utils.rpuf.frame.resetloc();
                                      print(RPTAGS.utils.locale.loc("APP_COLOR_NAME") .. " " .. RPTAGS.utils.locale.loc("FRAMES_ARE_RESET")) end,
  
      RPUFALPHA          = function() RPTAGS.utils.rpuf.frame.setbg(RPTAGS.utils.config.get("RPUFALPHA"), RPTAGS.utils.config.get("COLOR_RPUF")); end,
      COLOR_RPUF         = function() RPTAGS.utils.rpuf.frame.setbg(RPTAGS.utils.config.get("RPUFALPHA"), RPTAGS.utils.config.get("COLOR_RPUF")); end,
  
      NOTE_1_STRING      = function() RPTAGS.utils.tags.refreshAll() end,
      NOTE_2_STRING      = function() RPTAGS.utils.tags.refreshAll() end,
      NOTE_3_STRING      = function() RPTAGS.utils.tags.refreshAll() end,
  
      GAPSIZE            = function() RPTAGS.utils.rpuf.frame.resizeall(); end,
  
      ICONWIDTH          = function() RPTAGS.utils.rpuf.frame.resizeall(); end,
      INFOWIDTH          = function() RPTAGS.utils.rpuf.frame.resizeall(); end,
      PORTWIDTH          = function() RPTAGS.utils.rpuf.frame.resizeall(); end,
      STATUSHEIGHT       = function() RPTAGS.utils.rpuf.frame.resizeall(); end,
      DETAILHEIGHT       = function() RPTAGS.utils.rpuf.frame.resizeall(); end,
  
      FOCUSLAYOUT        = function() RPTAGS.utils.rpuf.frame.resizeall(); end,
      PLAYERLAYOUT       = function() RPTAGS.utils.rpuf.frame.resizeall(); end,
      TARGETLAYOUT       = function() RPTAGS.utils.rpuf.frame.resizeall(); end,
  
      INFOPANEL          = function() RPTAGS.utils.rpuf.frame.tagall('InfoPanel',      RPTAGS.utils.config.get('INFOPANEL'));   end,
      NAMEPANEL          = function() RPTAGS.utils.rpuf.frame.tagall('NamePanel',      RPTAGS.utils.config.get('NAMEPANEL'));   end,
      STATUSPANEL        = function() RPTAGS.utils.rpuf.frame.tagall('StatusBarPanel', RPTAGS.utils.config.get('STATUSPANEL')); end,
      DETAILPANEL        = function() RPTAGS.utils.rpuf.frame.tagall('DetailsPanel',   RPTAGS.utils.config.get("DETAILPANEL")); end,
  
      ICON_1             = function() RPTAGS.utils.rpuf.frame.tagall('Icon_1Panel',   RPTAGS.utils.config.get('ICON_1')); end,
      ICON_2             = function() RPTAGS.utils.rpuf.frame.tagall('Icon_2Panel',   RPTAGS.utils.config.get("ICON_2")); end,
      ICON_3             = function() RPTAGS.utils.rpuf.frame.tagall('Icon_3Panel',   RPTAGS.utils.config.get("ICON_3")); end,
      ICON_4             = function() RPTAGS.utils.rpuf.frame.tagall('Icon_4Panel',   RPTAGS.utils.config.get('ICON_4')); end,
      ICON_5             = function() RPTAGS.utils.rpuf.frame.tagall('Icon_5Panel',   RPTAGS.utils.config.get('ICON_5')); end,
      ICON_6             = function() RPTAGS.utils.rpuf.frame.tagall('Icon_6Panel',   RPTAGS.utils.config.get('ICON_6')); end,
  
      PORTRAIT_TOOLTIP   = function() RPTAGS.utils.rpuf.frame.tagall("Portrait", RPTAGS.utils.config.get("PORTRAIT_TOOLTIP"), "tooltip"); end,
      STATUS_TOOLTIP     = function() RPTAGS.utils.rpuf.frame.tagall("StatusBarPanel", RPTAGS.utils.config.get("STATUS_TOOLTIP"), "tooltip"); end,
      NAME_TOOLTIP       = function() RPTAGS.utils.rpuf.frame.tagall("NamePanel", RPTAGS.utils.config.get("NAME_TOOLTIP"), "tooltip"); end,
      INFO_TOOLTIP       = function() RPTAGS.utils.rpuf.frame.tagall("InfoPanel", RPTAGS.utils.config.get("INFO_TOOLTIP"), "tooltip"); end,
      DETAIL_TOOLTIP     = function() RPTAGS.utils.rpuf.frame.tagall("DetailsPanel", RPTAGS.utils.config.get("DETAIL_TOOLTIP"), "tooltip"); end,
      ICON_1_TOOLTIP     = function() RPTAGS.utils.rpuf.frame.tagall("Icon_1Panel", RPTAGS.utils.config.get("ICON_1_TOOLTIP"), "tooltip"); end,
      ICON_2_TOOLTIP     = function() RPTAGS.utils.rpuf.frame.tagall("Icon_2Panel", RPTAGS.utils.config.get("ICON_2_TOOLTIP"), "tooltip"); end,
      ICON_3_TOOLTIP     = function() RPTAGS.utils.rpuf.frame.tagall("Icon_3Panel", RPTAGS.utils.config.get("ICON_3_TOOLTIP"), "tooltip"); end,
      ICON_4_TOOLTIP     = function() RPTAGS.utils.rpuf.frame.tagall("Icon_4Panel", RPTAGS.utils.config.get("ICON_4_TOOLTIP"), "tooltip"); end,
      ICON_5_TOOLTIP     = function() RPTAGS.utils.rpuf.frame.tagall("Icon_5Panel", RPTAGS.utils.config.get("ICON_5_TOOLTIP"), "tooltip"); end,
      ICON_6_TOOLTIP     = function() RPTAGS.utils.rpuf.frame.tagall("Icon_6Panel", RPTAGS.utils.config.get("ICON_6_TOOLTIP"), "tooltip"); end,
  
      LOCK_FRAMES        = function() RPTAGS.utils.rpuf.frame.lockall() end,
  
      REF_TOPIC          = function() RPTAGS.utils.help.display(RPTAGS.utils.config.get('REF_TOPIC')); end,
      RPUF_WITH_ELVUI    = function() StaticPopup_Show("RPTAGS_CHANGE_MODE") end,
      RPUF_BACKDROP      = function() RPTAGS.utils.rpuf.frame.backdrop(RPTAGS.utils.config.get("RPUF_BACKDROP")) end,
      -- PORTRAIT_TYPE      = function() RPTAGS.utils.rpuf.frame.portraits() end,

    }, -- CALLBACKS
  };
  
  RPTAGS.const.CONFIG = settings;

  return "const-settings";
end);  -- startup function
