-- Init: sets up the structure in which we'll store our data and functions
--
local addOnName, RPTAGS = ...;

RPTAGS.addOnName = addOnName;

for _, item in ipairs({ 
    "cache", 
    "const",
    "get", 
    "locale", 
    "startup", 
    "utils", 
    }) do RPTAGS[item] = {} end;

local startupFrame = CreateFrame("frame")
startupFrame:RegisterEvent("ADDON_LOADED");
startupFrame:SetScript("OnEvent", 
  function(self, event, addOnLoaded)
    if addOnLoaded == addOnName
       then if not RP_TagsDB then RP_TagsDB = {} end;
            -- figure out which mode we're running in
            if     _G["ElvUI"] and RP_TagsDB.mode == "parallel" then RPTAGS.mode = "parallel"
            elseif _G["ElvUI"] and RP_TagsDB.mode == "elvui"    then RPTAGS.mode = "elvui"
            elseif _G["ElvUI"]                                  then RPTAGS.mode = "elvui"
            else                                                     RPTAGS.mode = "standalone"
            end; -- if

            if RPTAGS.mode ~= "standalone" then RP_TagsDB.mode = RPTAGS.mode; end;  -- only save it if we're not in standalone mode

            RPTAGS.cache.started = { "Description: This table contains a list of each startup routine excuted, in the order in which they were executed." };
            for _, startupRoutine in ipairs(RPTAGS.startup) 
            do  table.insert(RPTAGS.cache.started, startupRoutine(RPTAGS.mode));
            end; -- for
       end; -- if
    end); -- function
_G.RPTAGS = RPTAGS;
