local RPTAGS = RPTAGS;

table.insert(RPTAGS.startup, function() -- startup function
  
  local lang   = "enUS";
  local Locale = RPTAGS.locale[lang];
  
  -- if not RPTAGS.cache            then RPTAGS.cache            = {}; end;
  if not RPTAGS.cache.helpdata   then RPTAGS.cache.helpdata   = {}; end;
  if not RPTAGS.cache.helptopics then RPTAGS.cache.helptopics = {}; end;
  if not RPTAGS.cache.tagorder   then RPTAGS.cache.tagorder   = {}; end;
  -- if not RPTAGS.cache            then RPTAGS.cache = {} end;
  if not RPTAGS.cache.tagcache   then RPTAGS.cache.tagcache    = {}; end;
  
  local function makeCache(tag)
        if not RPTAGS.cache.tagcache[tag] then RPTAGS.cache.tagcache[tag] = {} end;
        return RPTAGS.cache.tagcache[tag];
        end;
  
  local TAG_DATA = RPTAGS.cache.TAG_DATA;
  -- --------------------------------------------------------------------------------------------------------------------------------------------------
  for _, tagGroup in ipairs(TAG_DATA)
  do  Locale["TAG_GROUP_" .. tagGroup.key] = tagGroup.title;
  
      local helpTopic = tagGroup.help .. "\n";
      table.insert(RPTAGS.cache.tagorder, {"submenu", tagGroup.title, tagGroup.help, } );
  
      for _, tagData in ipairs(tagGroup.tags)
      do  local tagName, aliases, label, desc = unpack(tagData);
          if   tagName
          then helpTopic = helpTopic .. "\n[".. tagName .. "] - "..desc;
               RPTAGS.cache.helpdata[tagName] = tagGroup.key;
               table.insert(RPTAGS.cache.tagorder, { "tag", desc, "[" .. tagName .. "]", } );
  
               if   tagGroup.external
               then local ExtagData = makeCache(tagName);
                          ExtagData.name = tagName;
                          ExtagData.desc = desc;
                          ExtagData.label = nil;
                          ExtagData.aliases = nil;
                          ExtagData["alias-for"] = nil;
                          ExtagData["label-for"] = nil;
                          ExtagData.external = true;
                          ExtagData.help = tagGroup.key;
                          ExtagData.group = tagGroup.key;
               else local RptagData = makeCache(tagName);
                          RptagData.name = tagName;
                          RptagData.desc = desc;
                          RptagData.label = label;
                          RptagData.aliases = aliases;
                          RptagData["alias-for"] = nil;
                          RptagData["label-for"] = nil;
                          RptagData.help    = tagGroup.key;
                          RptagData.group   = tagGroup.key;
       
                    if   label 
                    then local LabelData = makeCache(tagName .. "-label");
                               LabelData.name = tagName .. "-label";
                               LabelData.desc = desc;
                               LabelData.label = nil;
                               LabelData.aliases = nil;
                               LabelData["alias-for"] = nil;
                               LabelData["label-for"] = tagName;
                               LabelData.help = tagGroup.key; 
                               LabelData.group = tagGroup.key;
                    end; -- if label
  
                    if   aliases 
                    then for _, aka in ipairs(aliases)
                         do  local AliasData = makeCache(aka);
                                   AliasData.name = aka;
                                   AliasData.desc = desc;
                                   AliasData.label = label;
                                   AliasData.aliases = nil;
                                   AliasData["alias-for"] = tagName;
                                   AliasData["label-for"] = nil;
                                   AliasData.help = tagGroup.key;
                                   AliasData.group = tagGroup.key;
       
                             if   label -- labels for aliases
                             then local LabelData = makeCache(aka .. "-label");
                                        LabelData.name = aka .. "-label";
                                        LabelData.desc = desc;
                                        LabelData.label = nil;
                                        LabelData.aliases = nil;
                                        LabelData["alias-for"] = nil;
                                        LabelData["label-for"] = aka
                                        LabelData.help = tagGroup.help;
                                        LabelData.group = tagGroup.key;
                             end; -- if label for aliases
                         end; -- for aka
                    end; --  if aliases
               end; -- if not external
          else -- no tagName, so it's a separator
               table.insert(RPTAGS.cache.tagorder, { "sep", desc or "", nil });
               if desc then helpTopic = "\n" ..  helpTopic .. "\n" .. "[[" .. desc .. "]]\n"; else helpTopic = helpTopic .. "\n" end;
          end -- if tagName
      end; -- for tag
  
      Locale["HELPTOPIC_"  .. tagGroup.key]         = helpTopic;
      RPTAGS.cache.helptopics[tagGroup.key] = true;
  
      Locale["HELPTITLE_" .. tagGroup.key] = tagGroup.title;
  
  end; -- for tagGroup

  return "tagdata";
end); -- startup function  
