-- ------------------------------------------------------------------------------
-- RP Tags
-- by Oraibi, Moon Guard (US) server
--
-- Ora's twitter: http://twitter.com/oraibimoonguard
-- Download site: http://tinyurl.com/rptags-tukui
-- Documentation: http://tinyurl.com/rptags-wiki
--
-- ------------------------------------------------------------------------------
--
-- This work is licensed under the Creative Commons Attribution 4.0 International
-- (CC BY 4.0) license. To view a copy of the license, visit
--
--     https://creativecommons.org/licenses/by/4.0/
--
-- This license is acceptable for Free Cultural Works.
--
-- You are free to:
--
-- Share -- copy and redistribute the material in any medium or format
-- Adapt -- remix, transform, and build upon the material
--         for any purpose, even commercially.
-- 
-- The licensor cannot revoke these freedoms as long as you follow the 
-- license terms.
-- 
-- Under the following terms:
-- Attribution -- You must give appropriate credit, provide a link to the
--         license, and indicate if changes were made. You may do
--         so in any reasonable manner, but not in any way that
--         suggests the licensor endorses you or your use.
--
-- No additional restrictions -- You may not apply legal terms or
--         technological measures that legally restrict others from doing
--         anything the license permits.
--
-- Notices:
--
-- You do not have to comply with the license for elements of the material
-- in the public domain or where your use is permitted by an applicable
-- exception or limitation.
--
-- No warranties are given. The license may not give you all of the
-- permissions necessary for your intended use. For example, other rights
-- such as publicity, privacy, or moral rights may limit how you use the
-- material.
-- ------------------------------------------------------------------------------

  -- Utils-Import: Functions from trp3 or elsewhere

local RPTAGS     = RPTAGS;

table.insert(RPTAGS.startup, function() -- startup function
  local Utils      = RPTAGS.utils;
  local TRP3_API   = TRP3_API;
  
  if not Utils.import then Utils.import = {}; end;
  local Import = Utils.import;
  
  -- ------------------------------------------------------------------------------
  
  if RPTAGS.mode == "parallel" or RPTAGS.mode == "elvui" then 
    local E, _, _, _, _, _  = unpack(ElvUI); 
    local UF        = E:GetModule('UnitFrames');
    if not Import.elvui then Import.elvui = {}; end;
    local Elvui = Import.elvui;
    
    -- Function(s) available under RPTAGS.utils.import.elvui
    --
    Elvui.refreshFrame = function(frame) 
      if     frame == "party" then UF:CreateAndUpdateHeaderGroup('party')
      elseif frame == "raid"  then UF:CreateAndUpdateHeaderGroup("raid")
      else                         UF:CreateAndUpdateUF(frame);
      end; -- if
    end;
  
    Elvui.refreshAll = function() 
      UF:Update_AllFrames();
    end;
  end; 
  
  -- ------------------------------------------------------------------------------
  if not Import.trp3 then Import.trp3 = {}; end;
  local Trp3 = Import.trp3;
  --
  -- Functions available under RPTAGS.utils.import.trp3
  Trp3.register     = { addon  = TRP3_API.module.registerModule,
                        event  = TRP3_API.events.listenToEvent,
                        callback = TRP3_API.Events.registerCallback,
                        config = { page    = TRP3_API.configuration.registerConfigurationPage,
                                   key     = TRP3_API.configuration.registerConfigKey,
                                   handler = TRP3_API.configuration.registerHandler },
                      };
  
  Trp3.colorCode    = TRP3_API.utils.color.colorCode;
  Trp3.colorCodeFloat    = TRP3_API.utils.color.colorCodeFloat;
  Trp3.getData      = TRP3_API.profile.getData;
  Trp3.getProfile   = TRP3_API.register.getUnitIDCurrentProfileSafe;
  Trp3.getTrpName   = TRP3_API.r.name;
  Trp3.getUnitID    = TRP3_API.utils.str.getUnitID;
  Trp3.getValue        = TRP3_API.configuration.getValue;
  Trp3.setValue        = TRP3_API.configuration.setValue;
  Trp3.registerHandler = TRP3_API.configuration.registerHandler;
  Trp3.hexaToNumber = TRP3_API.utils.color.hexaToNumber;
  Trp3.isPlayerIC   = TRP3_API.dashboard.isPlayerIC;
  Trp3.popup        = TRP3_API.Ellyb.Popups;
  Trp3.profileSize  = TRP3_API.communication.estimateStructureLoad;
  Trp3.sanitize     = TRP3_API.utils.str.sanitize;
  Trp3.gameEvent    = TRP3_API.utils.event.fireEvent;
  Trp3.musicList    = TRP3_API.utils.resources.getMusicList;
  Trp3.unitIDToInfo = TRP3_API.utils.str.unitIDToInfo;
  Trp3.relation = { get = TRP3_API.register.relation.getRelation,
                    texture = TRP3_API.register.relation.getRelationTexture,
                    text = TRP3_API.register.relation.getRelationText,
                    color = TRP3_API.register.relation.getColor, };

  return "utils-import"
end); -- startup function 
